=== debian/changelog ===
nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-4) unstable; urgency=medium

  * add patches cherry-picked upstream:
    + fix build against fmt 11
    + break up large key requests into smaller ones;
      closes: bug#f6788ec, thanks to Shengqi Chen
    + add more options for screen sharing frame rate
  * update copyright info: update coverage
  * depend on qt6-svg-plugins;
    closes: bug#1089609, thanks to Russell Coker and ZenWalker

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 12 Jan 2025 18:30:29 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-3) unstable; urgency=medium

  * stop (build-)depend explicitly om qml6 packages;
    stop depend on gstreamer1.0-qt5;
    recommend (not depend on) gstreamer1.0-nice
  * override qmldeps for
    missing modules nheko Qt6GLVideoItem Qt6D3D11VideoItem

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 09 Nov 2024 12:52:14 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-2) unstable; urgency=medium

  * auto-resolve dependencies on qml modules,
     tolerating errors as GStreamer qml modules are missing;
    build-depend on dh-sequence-qmldeps qml6-module-qtmultimedia

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Oct 2024 06:34:04 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file:
    + bump versions for mtxclient coeurl
    + modernize search runes for coeurl
  * drop patch cherry-picked upstream,
    obsoleted by upstream changes
  * unfuzz patches
  * update copyright info: update coverage
  * build against Qt6 libraries
  * stop build-depend on libnice-dev libsodium-dev zlib1g-dev
  * suggest (not recommend) kimageformat6-plugins
  * update DEP-3 patch headers
  * add patches cherry-picked upstream:
    + fix disabling a room ping
    + fix avatar change rendering
  * declare compliance with Debian Policy 4.7.0
  * relax to build-depend unversioned
    when version is satisfied in Debian stable

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Jun 2024 12:35:40 +0200

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-2) unstable; urgency=medium

  * revive and acknowledge NMU;
    closes: bug#1042967, thanks to Boyuan Yang
  * revert to do parallel build,
    and relax compiler optimization for armel and armhf
    same as other weak arches

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 04 Apr 2024 21:17:09 +0200

nheko (0.11.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Force non-parallel build, hopefully fix OOM with
    armhf buildd build.
  * debian/patches/:
    + 0003-Fix-voip-defaults-being-incorrect-because-OS-constan.patch:
      Apply upstream fix on launch crashes with arm64. (Closes: #1042967)

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Dec 2023 12:54:11 -0500
