=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto \
https://github.com/Nheko-reborn/nheko/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@ group

opts=\
component=mtxclient,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-mtxclient-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/mtxclient/tags \
.*?v(0\.10\.0)@ARCHIVE_EXT@ group

opts=\
component=lmdbxx,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-lmdbxx-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/lmdbxx/tags \
.*?(1\.0\.0)@ARCHIVE_EXT@ group

opts=\
component=coeurl,\
searchmode=plain,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-coeurl-$1/,\
dversionmangle=auto \
https://nheko.im/nheko-reborn/coeurl/tags?sort=updated_desc \
-/archive/v\d[\d.]+/coeurl-v(0\.3\.1)@ARCHIVE_EXT@ group
