## nheko 0.12.1%2B~0.10.1%2B~1.0.0%2B~0.3.1

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: nheko
-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders:
  Hubert Chathi <uhoreg@debian.org>,
  Jonas Smedegaard <dr@jones.dk>,
 Section: net
-Priority: optional
 Build-Depends:
  asciidoc-base,
  cmake,
@@ -35,11 +35,10 @@
  qt6-svg-dev,
  qt6-tools-dev,
  qtkeychain-qt6-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
 Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
 Homepage: https://github.com/Nheko-Reborn/nheko
-Rules-Requires-Root: no
 
 Package: nheko
 Architecture: any
