## nheko 0.12.1+~0.10.1+~1.0.0+~0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13..3.21)
+cmake_minimum_required(VERSION 3.13...3.21)
 
 option(APPVEYOR_BUILD "Build on appveyor" OFF)
 option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
@@ -25,8 +25,8 @@
 option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
 include("cmake/HunterGate.cmake")
 HunterGate(
-    URL "https://github.com/cpp-pm/hunter/archive/v0.25.5.tar.gz"
-    SHA1 "a20151e4c0740ee7d0f9994476856d813cdead29"
+    URL "https://github.com/cpp-pm/hunter/archive/v0.26.1.tar.gz"
+    SHA1 "e41ac7a18c49b35ebac99ff2b5244317b2638a65"
     LOCAL
 )
 
@@ -50,6 +50,7 @@
 project(nheko LANGUAGES CXX C)
 
 option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${HUNTER_ENABLED})
+option(USE_BUNDLED_FMT "Use the bundled version of {fmt}." ${HUNTER_ENABLED})
 option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
 option(USE_BUNDLED_GTEST "Use the bundled version of Google Test." ${HUNTER_ENABLED})
 option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${HUNTER_ENABLED})
@@ -114,7 +115,7 @@
 
 set(CPACK_PACKAGE_VERSION_MAJOR "0")
 set(CPACK_PACKAGE_VERSION_MINOR "12")
-set(CPACK_PACKAGE_VERSION_PATCH "0")
+set(CPACK_PACKAGE_VERSION_PATCH "1")
 set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
 set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
 set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})
@@ -179,6 +180,12 @@
     find_package(PkgConfig REQUIRED) 
     pkg_check_modules(libcurl REQUIRED IMPORTED_TARGET libcurl)
 endif()
+
+# fmt
+if(USE_BUNDLED_FMT)
+    hunter_add_package_safe(fmt)
+endif()
+find_package(fmt 8.0.0 CONFIG REQUIRED)
 
 # spdlog
 if(USE_BUNDLED_SPDLOG)
@@ -351,13 +358,3 @@
 configure_file(cmake/nheko.h config/nheko.h)
 
 #
-# Declare source and header files.
-#
-set(SRC_FILES
-    # Emoji
-    src/emoji/Provider.cpp
-    src/emoji/Provider.h
-    src/emoji/Emoji.cpp
-    src/emoji/Emoji.h
-
-    # Timeline
