=== meson_options.txt ===
option('tests', type : 'boolean', value : false, description : 'Build the tests')
option('examples', type : 'boolean', value : false, description : 'Build the examples')
