=== debian/changelog ===
nheko (0.12.1+~0.10.1+~1.0.0+~0.3.1-2) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix most reply rendering issues with qt 6.9.2
  * update watch file: use file format 5

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 24 Sep 2025 01:40:06 +0200

nheko (0.12.1+~0.10.1+~1.0.0+~0.3.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file: bump version prefix for embedded mtxclient
  * drop patches cherry-picked upstream, obsoleted by upstream changes
  * unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Aug 2025 15:32:00 +0200

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-6) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Aug 2025 14:08:45 +0200

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-5) experimental; urgency=medium

  * add patch cherry-picked upstream
    to fix verification with new Element clients
  * declare compliance with Debian Policy 4.7.2

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 03 Aug 2025 11:33:55 +0200
