=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: nheko
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
+Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders:
  Hubert Chathi <uhoreg@debian.org>,
  Jonas Smedegaard <dr@jones.dk>,
 Section: net
+Priority: optional
 Build-Depends:
  asciidoc-base,
  cmake,
@@ -35,10 +35,11 @@
  qt6-svg-dev,
  qt6-tools-dev,
  qtkeychain-qt6-dev,
-Standards-Version: 4.7.3
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
 Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
 Homepage: https://github.com/Nheko-Reborn/nheko
+Rules-Requires-Root: no
 
 Package: nheko
 Architecture: any
