=== debian/watch ===
version: 5
Version-Schema: group
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

Template: Github
Owner: Nheko-reborn
Project: nheko
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@SEMANTIC_VERSION@

Component: mtxclient
Template: Github
Owner: Nheko-reborn
Project: mtxclient

Component: lmdbxx
Template: Github
Owner: Nheko-reborn
Project: lmdbxx

Component: coeurl
Template: Gitlab
Dist: https://nheko.im/nheko-reborn/coeurl
version-Mangle: s/v//
